'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true,
});
Object.defineProperty(exports, 'ToggleSwitch', {
  enumerable: true,
  get: function () {
    return ToggleSwitch;
  },
});
const _interop_require_default = require('@swc/helpers/_/_interop_require_default');
const _interop_require_wildcard = require('@swc/helpers/_/_interop_require_wildcard');
const _react = /*#__PURE__*/ _interop_require_wildcard._(require('react'));
const _classnames = /*#__PURE__*/ _interop_require_default._(
  require('classnames'),
);
const _index = require('../../utils/index.js');
const ToggleSwitch = _react.forwardRef((props, ref) => {
  let {
    disabled = false,
    labelPosition = 'right',
    label,
    className,
    style,
    size = 'default',
    labelProps = {},
    icon: iconProp,
    ...rest
  } = props;
  let shouldShowIcon =
    void 0 === iconProp || (null !== iconProp && 'small' !== size);
  return _react.createElement(
    _index.Box,
    {
      as: label ? 'label' : 'div',
      className: (0, _classnames.default)(
        'iui-toggle-switch-wrapper',
        {
          'iui-disabled': disabled,
          'iui-label-on-right': label && 'right' === labelPosition,
          'iui-label-on-left': label && 'left' === labelPosition,
        },
        className,
      ),
      'data-iui-size': size,
      style: style,
    },
    _react.createElement(_index.Box, {
      as: 'input',
      className: 'iui-toggle-switch',
      type: 'checkbox',
      role: 'switch',
      disabled: disabled,
      ref: ref,
      ...rest,
    }),
    shouldShowIcon &&
      _react.createElement(
        _index.Box,
        {
          as: 'span',
          className: 'iui-toggle-switch-icon',
          'aria-hidden': true,
        },
        iconProp || _react.createElement(_index.SvgCheckmark, null),
      ),
    label &&
      _react.createElement(
        _index.Box,
        {
          as: 'span',
          ...labelProps,
          className: (0, _classnames.default)(
            'iui-toggle-switch-label',
            labelProps?.className,
          ),
        },
        label,
      ),
  );
});
if ('development' === process.env.NODE_ENV)
  ToggleSwitch.displayName = 'ToggleSwitch';
